diff -urN sbcl-0.8.16/src/runtime/purify.c sbcl-0.8.16.patched/src/runtime/purify.c
--- sbcl-0.8.16/src/runtime/purify.c	2004-09-14 19:25:17.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/purify.c	2004-10-26 17:08:22.000000000 +0200
@@ -199,11 +199,11 @@
 	/* Is it plausible cons? */
 	if ((is_lisp_pointer(start_addr[0])
 	    || ((start_addr[0] & 3) == 0) /* fixnum */
-	    || (widetag_of(start_addr[0]) == BASE_CHAR_WIDETAG)
+	    || (widetag_of(start_addr[0]) == CHARACTER_WIDETAG)
 	    || (widetag_of(start_addr[0]) == UNBOUND_MARKER_WIDETAG))
 	   && (is_lisp_pointer(start_addr[1])
 	       || ((start_addr[1] & 3) == 0) /* fixnum */
-	       || (widetag_of(start_addr[1]) == BASE_CHAR_WIDETAG)
+	       || (widetag_of(start_addr[1]) == CHARACTER_WIDETAG)
 	       || (widetag_of(start_addr[1]) == UNBOUND_MARKER_WIDETAG))) {
 	    break;
 	} else {
@@ -247,7 +247,7 @@
 	}
 	switch (widetag_of(start_addr[0])) {
 	case UNBOUND_MARKER_WIDETAG:
-	case BASE_CHAR_WIDETAG:
+	case CHARACTER_WIDETAG:
 	    if (pointer_filter_verbose) {
 		fprintf(stderr,"*Wo3: %x %x %x\n", (unsigned int) pointer, 
 			(unsigned int) start_addr, *start_addr);
@@ -285,6 +285,7 @@
 #endif
 	case SIMPLE_ARRAY_WIDETAG:
 	case COMPLEX_BASE_STRING_WIDETAG:
+	case COMPLEX_CHARACTER_STRING_WIDETAG:
 	case COMPLEX_VECTOR_NIL_WIDETAG:
 	case COMPLEX_BIT_VECTOR_WIDETAG:
 	case COMPLEX_VECTOR_WIDETAG:
@@ -301,6 +302,7 @@
 #endif
 	case SIMPLE_ARRAY_NIL_WIDETAG:
 	case SIMPLE_BASE_STRING_WIDETAG:
+	case SIMPLE_CHARACTER_STRING_WIDETAG:
 	case SIMPLE_BIT_VECTOR_WIDETAG:
 	case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
 	case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
@@ -890,92 +892,96 @@
 {
     switch (widetag_of(header)) {
 	/* FIXME: this needs a reindent */
-      case BIGNUM_WIDETAG:
-      case SINGLE_FLOAT_WIDETAG:
-      case DOUBLE_FLOAT_WIDETAG:
+    case BIGNUM_WIDETAG:
+    case SINGLE_FLOAT_WIDETAG:
+    case DOUBLE_FLOAT_WIDETAG:
 #ifdef LONG_FLOAT_WIDETAG
-      case LONG_FLOAT_WIDETAG:
+    case LONG_FLOAT_WIDETAG:
 #endif
 #ifdef COMPLEX_SINGLE_FLOAT_WIDETAG
-      case COMPLEX_SINGLE_FLOAT_WIDETAG:
+    case COMPLEX_SINGLE_FLOAT_WIDETAG:
 #endif
 #ifdef COMPLEX_DOUBLE_FLOAT_WIDETAG
-      case COMPLEX_DOUBLE_FLOAT_WIDETAG:
+    case COMPLEX_DOUBLE_FLOAT_WIDETAG:
 #endif
 #ifdef COMPLEX_LONG_FLOAT_WIDETAG
-      case COMPLEX_LONG_FLOAT_WIDETAG:
+    case COMPLEX_LONG_FLOAT_WIDETAG:
 #endif
-      case SAP_WIDETAG:
-	  return ptrans_unboxed(thing, header);
-
-      case RATIO_WIDETAG:
-      case COMPLEX_WIDETAG:
-      case SIMPLE_ARRAY_WIDETAG:
-      case COMPLEX_BASE_STRING_WIDETAG:
-      case COMPLEX_BIT_VECTOR_WIDETAG:
-      case COMPLEX_VECTOR_NIL_WIDETAG:
-      case COMPLEX_VECTOR_WIDETAG:
-      case COMPLEX_ARRAY_WIDETAG:
+    case SAP_WIDETAG:
+	return ptrans_unboxed(thing, header);
+	
+    case RATIO_WIDETAG:
+    case COMPLEX_WIDETAG:
+    case SIMPLE_ARRAY_WIDETAG:
+    case COMPLEX_BASE_STRING_WIDETAG:
+    case COMPLEX_CHARACTER_STRING_WIDETAG:
+    case COMPLEX_BIT_VECTOR_WIDETAG:
+    case COMPLEX_VECTOR_NIL_WIDETAG:
+    case COMPLEX_VECTOR_WIDETAG:
+    case COMPLEX_ARRAY_WIDETAG:
         return ptrans_boxed(thing, header, constant);
 	
-      case VALUE_CELL_HEADER_WIDETAG:
-      case WEAK_POINTER_WIDETAG:
+    case VALUE_CELL_HEADER_WIDETAG:
+    case WEAK_POINTER_WIDETAG:
         return ptrans_boxed(thing, header, 0);
-
-      case SYMBOL_HEADER_WIDETAG:
+	
+    case SYMBOL_HEADER_WIDETAG:
         return ptrans_boxed(thing, header, 0);
-
-      case SIMPLE_ARRAY_NIL_WIDETAG:
+	
+    case SIMPLE_ARRAY_NIL_WIDETAG:
         return ptrans_vector(thing, 0, 0, 0, constant);
-
-      case SIMPLE_BASE_STRING_WIDETAG:
+	
+    case SIMPLE_BASE_STRING_WIDETAG:
         return ptrans_vector(thing, 8, 1, 0, constant);
-
-      case SIMPLE_BIT_VECTOR_WIDETAG:
+	
+    case SIMPLE_CHARACTER_STRING_WIDETAG:
+	return ptrans_vector(thing, 32, 1, 0, constant);
+	
+    case SIMPLE_BIT_VECTOR_WIDETAG:
         return ptrans_vector(thing, 1, 0, 0, constant);
-
-      case SIMPLE_VECTOR_WIDETAG:
+	
+    case SIMPLE_VECTOR_WIDETAG:
         return ptrans_vector(thing, 32, 0, 1, constant);
-
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
+	
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
         return ptrans_vector(thing, 2, 0, 0, constant);
-
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
+	
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
         return ptrans_vector(thing, 4, 0, 0, constant);
-
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_8_WIDETAG:
+	
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_8_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG
-      case SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG:
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_7_WIDETAG:
+    case SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG:
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_7_WIDETAG:
 #endif
         return ptrans_vector(thing, 8, 0, 0, constant);
 
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_16_WIDETAG:
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_16_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG
-      case SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG:
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_15_WIDETAG:
+    case SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG:
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_15_WIDETAG:
 #endif
         return ptrans_vector(thing, 16, 0, 0, constant);
-
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_32_WIDETAG:
+	
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_32_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG
-      case SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG:
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_29_WIDETAG:
+    case SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG:
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_29_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG
-      case SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG:
-      case SIMPLE_ARRAY_UNSIGNED_BYTE_31_WIDETAG:
+    case SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG:
+    case SIMPLE_ARRAY_UNSIGNED_BYTE_31_WIDETAG:
 #endif
         return ptrans_vector(thing, 32, 0, 0, constant);
-
-      case SIMPLE_ARRAY_SINGLE_FLOAT_WIDETAG:
+	
+    case SIMPLE_ARRAY_SINGLE_FLOAT_WIDETAG:
         return ptrans_vector(thing, 32, 0, 0, constant);
-
-      case SIMPLE_ARRAY_DOUBLE_FLOAT_WIDETAG:
+	
+    case SIMPLE_ARRAY_DOUBLE_FLOAT_WIDETAG:
         return ptrans_vector(thing, 64, 0, 0, constant);
-
+	
 #ifdef SIMPLE_ARRAY_LONG_FLOAT_WIDETAG
-      case SIMPLE_ARRAY_LONG_FLOAT_WIDETAG:
+    case SIMPLE_ARRAY_LONG_FLOAT_WIDETAG:
 #ifdef LISP_FEATURE_X86
         return ptrans_vector(thing, 96, 0, 0, constant);
 #endif
@@ -985,17 +991,17 @@
 #endif
 
 #ifdef SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG
-      case SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG:
+    case SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG:
         return ptrans_vector(thing, 64, 0, 0, constant);
 #endif
 
 #ifdef SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG
-      case SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG:
+    case SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG:
         return ptrans_vector(thing, 128, 0, 0, constant);
 #endif
 
 #ifdef SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG
-      case SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG:
+    case SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG:
 #ifdef LISP_FEATURE_X86
         return ptrans_vector(thing, 192, 0, 0, constant);
 #endif
@@ -1004,16 +1010,16 @@
 #endif
 #endif
 
-      case CODE_HEADER_WIDETAG:
+    case CODE_HEADER_WIDETAG:
         return ptrans_code(thing);
 
-      case RETURN_PC_HEADER_WIDETAG:
+    case RETURN_PC_HEADER_WIDETAG:
         return ptrans_returnpc(thing, header);
 
-      case FDEFN_WIDETAG:
+    case FDEFN_WIDETAG:
 	return ptrans_fdefn(thing, header);
 
-      default:
+    default:
         /* Should only come across other pointers to the above stuff. */
         gc_abort();
 	return NIL;
@@ -1124,110 +1130,115 @@
             /* It's an other immediate. Maybe the header for an unboxed */
             /* object. */
             switch (widetag_of(thing)) {
-              case BIGNUM_WIDETAG:
-              case SINGLE_FLOAT_WIDETAG:
-              case DOUBLE_FLOAT_WIDETAG:
+	    case BIGNUM_WIDETAG:
+	    case SINGLE_FLOAT_WIDETAG:
+	    case DOUBLE_FLOAT_WIDETAG:
 #ifdef LONG_FLOAT_WIDETAG
-              case LONG_FLOAT_WIDETAG:
+	    case LONG_FLOAT_WIDETAG:
 #endif
-              case SAP_WIDETAG:
+	    case SAP_WIDETAG:
                 /* It's an unboxed simple object. */
                 count = HeaderValue(thing)+1;
                 break;
 
-              case SIMPLE_VECTOR_WIDETAG:
+	    case SIMPLE_VECTOR_WIDETAG:
 		  if (HeaderValue(thing) == subtype_VectorValidHashing) {
                     *addr = (subtype_VectorMustRehash << N_WIDETAG_BITS) |
                         SIMPLE_VECTOR_WIDETAG;
 		  }
                 count = 1;
                 break;
-
-	      case SIMPLE_ARRAY_NIL_WIDETAG:
+		
+	    case SIMPLE_ARRAY_NIL_WIDETAG:
 		count = 2;
 		break;
-
-              case SIMPLE_BASE_STRING_WIDETAG:
+		
+	    case SIMPLE_BASE_STRING_WIDETAG:
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length)+1,8)+2,2);
                 break;
 
-              case SIMPLE_BIT_VECTOR_WIDETAG:
+	    case SIMPLE_CHARACTER_STRING_WIDETAG:
+		vector = (struct vector *)addr;
+		count = CEILING(NWORDS(fixnum_value(vector->length)+1,32)+2,2);
+		break;
+
+	    case SIMPLE_BIT_VECTOR_WIDETAG:
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),1)+2,2);
                 break;
 
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),2)+2,2);
                 break;
 
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),4)+2,2);
                 break;
 
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_8_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_8_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG
-              case SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG:
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_7_WIDETAG:
+	    case SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_7_WIDETAG:
 #endif
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),8)+2,2);
                 break;
-
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_16_WIDETAG:
+		
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_16_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG
-              case SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG:
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_15_WIDETAG:
+	    case SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_15_WIDETAG:
 #endif
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),16)+2,2);
                 break;
 
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_32_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_32_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG
-              case SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG:
-  	      case SIMPLE_ARRAY_UNSIGNED_BYTE_29_WIDETAG:
+	    case SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_29_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG
-              case SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG:
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_31_WIDETAG:
+	    case SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_31_WIDETAG:
 #endif
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),32)+2,2);
                 break;
 
 #if N_WORD_BITS == 64
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_64_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_64_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_61_WIDETAG
-              case SIMPLE_ARRAY_SIGNED_BYTE_61_WIDETAG:
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_60_WIDETAG:
+	    case SIMPLE_ARRAY_SIGNED_BYTE_61_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_60_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_64_WIDETAG
-              case SIMPLE_ARRAY_SIGNED_BYTE_64_WIDETAG:
-              case SIMPLE_ARRAY_UNSIGNED_BYTE_63_WIDETAG:
+	    case SIMPLE_ARRAY_SIGNED_BYTE_64_WIDETAG:
+	    case SIMPLE_ARRAY_UNSIGNED_BYTE_63_WIDETAG:
 #endif
                 vector = (struct vector *)addr;
                 count = CEILING(NWORDS(fixnum_value(vector->length),64)+2,2);
                 break;
 #endif
 
-              case SIMPLE_ARRAY_SINGLE_FLOAT_WIDETAG:
+	    case SIMPLE_ARRAY_SINGLE_FLOAT_WIDETAG:
                 vector = (struct vector *)addr;
                 count = CEILING(fixnum_value(vector->length)+2,2);
                 break;
 
-              case SIMPLE_ARRAY_DOUBLE_FLOAT_WIDETAG:
+	    case SIMPLE_ARRAY_DOUBLE_FLOAT_WIDETAG:
 #ifdef SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG
-              case SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG:
+	    case SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG:
 #endif
                 vector = (struct vector *)addr;
                 count = fixnum_value(vector->length)*2+2;
                 break;
 
 #ifdef SIMPLE_ARRAY_LONG_FLOAT_WIDETAG
-              case SIMPLE_ARRAY_LONG_FLOAT_WIDETAG:
+	    case SIMPLE_ARRAY_LONG_FLOAT_WIDETAG:
                 vector = (struct vector *)addr;
 #ifdef LISP_FEATURE_X86
                 count = fixnum_value(vector->length)*3+2;
@@ -1239,14 +1250,14 @@
 #endif
 
 #ifdef SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG
-              case SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG:
+	    case SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG:
                 vector = (struct vector *)addr;
                 count = fixnum_value(vector->length)*4+2;
                 break;
 #endif
 
 #ifdef SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG
-              case SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG:
+	    case SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG:
                 vector = (struct vector *)addr;
 #ifdef LISP_FEATURE_X86
                 count = fixnum_value(vector->length)*6+2;
@@ -1257,7 +1268,7 @@
                 break;
 #endif
 
-              case CODE_HEADER_WIDETAG:
+	    case CODE_HEADER_WIDETAG:
 #ifndef LISP_FEATURE_X86
                 gc_abort(); /* no code headers in static space */
 #else
@@ -1265,16 +1276,16 @@
 #endif
                 break;
 
-              case SIMPLE_FUN_HEADER_WIDETAG:
-              case RETURN_PC_HEADER_WIDETAG:
+	    case SIMPLE_FUN_HEADER_WIDETAG:
+	    case RETURN_PC_HEADER_WIDETAG:
                 /* We should never hit any of these, 'cause they occur
                  * buried in the middle of code objects. */
                 gc_abort();
 		break;
 
 #ifdef LISP_FEATURE_X86
-	      case CLOSURE_HEADER_WIDETAG:
-	      case FUNCALLABLE_INSTANCE_HEADER_WIDETAG:
+	    case CLOSURE_HEADER_WIDETAG:
+	    case FUNCALLABLE_INSTANCE_HEADER_WIDETAG:
 		/* The function self pointer needs special care on the
 		 * x86 because it is the real entry point. */
 		{
@@ -1287,20 +1298,20 @@
 		break;
 #endif
 
-              case WEAK_POINTER_WIDETAG:
+	    case WEAK_POINTER_WIDETAG:
                 /* Weak pointers get preserved during purify, 'cause I
 		 * don't feel like figuring out how to break them. */
                 pscav(addr+1, 2, constant);
                 count = 4;
                 break;
 
-	      case FDEFN_WIDETAG:
+	    case FDEFN_WIDETAG:
 		/* We have to handle fdefn objects specially, so we
 		 * can fix up the raw function address. */
 		count = pscav_fdefn((struct fdefn *)addr);
 		break;
 
-              default:
+	    default:
                 count = 1;
                 break;
             }
diff -urN sbcl-0.8.16/src/runtime/runtime.c sbcl-0.8.16.patched/src/runtime/runtime.c
--- sbcl-0.8.16/src/runtime/runtime.c	2004-02-25 18:41:51.000000000 +0100
+++ sbcl-0.8.16.patched/src/runtime/runtime.c	2004-10-26 17:08:22.000000000 +0200
@@ -28,6 +28,7 @@
 #include <signal.h>
 #include <sched.h>
 #include <errno.h>
+#include <locale.h>
 
 #if defined(SVR4) || defined(__linux__)
 #include <time.h>
@@ -189,6 +190,8 @@
 
     lispobj initial_function;
 
+    setlocale(LC_ALL, "");
+
     /* KLUDGE: os_vm_page_size is set by os_init(), and on some
      * systems (e.g. Alpha) arch_init() needs need os_vm_page_size, so
      * it must follow os_init(). -- WHN 2000-01-26 */
diff -urN sbcl-0.8.16/src/runtime/search.c sbcl-0.8.16.patched/src/runtime/search.c
--- sbcl-0.8.16/src/runtime/search.c	2004-08-10 02:20:47.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/search.c	2004-10-26 17:08:22.000000000 +0200
@@ -47,6 +47,8 @@
 	if (lowtag_of(symbol->name) == OTHER_POINTER_LOWTAG) {
             symbol_name = (struct vector *)native_pointer(symbol->name);
             if (is_valid_lisp_addr((os_vm_address_t)symbol_name) &&
+		/* FIXME: Broken with more than one type of string
+		   (i.e. even broken given (VECTOR NIL) */
 		widetag_of(symbol_name->header) == SIMPLE_BASE_STRING_WIDETAG &&
 		strcmp((char *)symbol_name->data, name) == 0)
                 return 1;
diff -urN sbcl-0.8.16/tests/character.pure.lisp sbcl-0.8.16.patched/tests/character.pure.lisp
--- sbcl-0.8.16/tests/character.pure.lisp	2002-12-12 12:47:37.000000000 +0100
+++ sbcl-0.8.16.patched/tests/character.pure.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -54,3 +54,10 @@
                 (digit-char 4 1)
                 (digit-char 4 37)))
   (assert (raises-error? (apply (car form) (mapcar 'eval (cdr form))) type-error)))
+
+(dotimes (i 256)
+  (let* ((char (code-char i))
+         (graphicp (graphic-char-p char))
+         (name (char-name char)))
+    (unless graphicp
+      (assert name))))
diff -urN sbcl-0.8.16/tests/compiler.test.sh sbcl-0.8.16.patched/tests/compiler.test.sh
--- sbcl-0.8.16/tests/compiler.test.sh	2004-07-19 22:13:23.000000000 +0200
+++ sbcl-0.8.16.patched/tests/compiler.test.sh	2004-10-26 17:08:22.000000000 +0200
@@ -286,6 +286,12 @@
 EOF
 expect_failed_compile $tmpfilename
 
+# This should be clean
+cat > $tmpfilename <<EOF
+(defvar *string* (make-string 10 :element-type 'base-char))
+EOF
+expect_clean_compile $tmpfilename
+
 rm $tmpfilename
 rm $compiled_tmpfilename
 
diff -urN sbcl-0.8.16/tests/dump.impure-cload.lisp sbcl-0.8.16.patched/tests/dump.impure-cload.lisp
--- sbcl-0.8.16/tests/dump.impure-cload.lisp	2004-09-10 16:22:38.000000000 +0200
+++ sbcl-0.8.16.patched/tests/dump.impure-cload.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -98,4 +98,30 @@
 (defvar *2-bit* #.(make-array 5 :element-type '(unsigned-byte 2) :initial-element 0))
 (defvar *4-bit* #.(make-array 5 :element-type '(unsigned-byte 4) :initial-element 1))
 
+;;; tests for constant coalescing (and absence of such) in the
+;;; presence of strings.
+(progn
+  (defvar *character-string-1* #.(make-string 5 :initial-element #\a))
+  (defvar *character-string-2* #.(make-string 5 :initial-element #\a))
+  (assert (eq *character-string-1* *character-string-2*))
+  (assert (typep *character-string-1* '(simple-array character (5)))))
+
+(progn
+  (defvar *base-string-1*
+    #.(make-string 5 :initial-element #\b :element-type 'base-char))
+  (defvar *base-string-2*
+    #.(make-string 5 :initial-element #\b :element-type 'base-char))
+  (assert (eq *base-string-1* *base-string-2*))
+  (assert (typep *base-string-1* '(simple-base-string 5))))
+
+#-#.(cl:if (cl:subtypep 'cl:character 'cl:base-char) '(and) '(or))
+(progn
+  (defvar *base-string*
+    #.(make-string 5 :element-type 'base-char :initial-element #\x))
+  (defvar *character-string*
+    #.(make-string 5 :initial-element #\x))
+  (assert (not (eq *base-string* *character-string*)))
+  (assert (typep *base-string* 'base-string))
+  (assert (typep *character-string* '(vector character))))
+
 (sb-ext:quit :unix-status 104) ; success
diff -urN sbcl-0.8.16/tests/pathnames.impure.lisp sbcl-0.8.16.patched/tests/pathnames.impure.lisp
--- sbcl-0.8.16/tests/pathnames.impure.lisp	2004-08-18 19:23:18.000000000 +0200
+++ sbcl-0.8.16.patched/tests/pathnames.impure.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -309,6 +309,7 @@
 		  (parse-namestring "SCRATCH:FOO.TXT.NEWEST")
 		  (parse-namestring "SCRATCH:FOO.TXT"))))
   (dolist (p pathnames)
+    (print p)
     (handler-case
 	(let ((*print-readably* t))
 	  (assert (equal (read-from-string (format nil "~S" p)) p)))
diff -urN sbcl-0.8.16/tests/seq.impure.lisp sbcl-0.8.16.patched/tests/seq.impure.lisp
--- sbcl-0.8.16/tests/seq.impure.lisp	2004-06-29 10:51:02.000000000 +0200
+++ sbcl-0.8.16.patched/tests/seq.impure.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -362,24 +362,45 @@
 ;;; KLUDGE: not all in one big form because that causes SBCL to spend
 ;;; an absolute age trying to compile it.
 (defmacro sequence-bounding-indices-test (&body body)
-  `(locally
-    ;; See Issues 332 [and 333(!)] in the CLHS
-    (declare (optimize (safety 3)))
-    (let ((string (make-array 10
-			      :fill-pointer 5
-			      :initial-element #\a
-			      :element-type 'base-char)))
-      (flet ((reset ()
-	       (setf (fill-pointer string) 10)
-	       (fill string #\a)
-	       (setf (fill-pointer string) 5)))
-	(declare (ignorable #'reset))
-	,@body))))
+  `(progn
+    (locally
+      ;; See Issues 332 [and 333(!)] in the CLHS
+      (declare (optimize (safety 3)))
+      (let ((string (make-array 10
+				:fill-pointer 5
+				:initial-element #\a
+				:element-type 'base-char)))
+	,(car body)
+	(format t "... BASE-CHAR")
+	(finish-output)
+	(flet ((reset ()
+		 (setf (fill-pointer string) 10)
+		 (fill string #\a)
+		 (setf (fill-pointer string) 5)))
+	  (declare (ignorable #'reset))
+	  ,@(cdr body))))
+    (locally
+      ;; See Issues 332 [and 333(!)] in the CLHS
+      (declare (optimize (safety 3)))
+      (let ((string (make-array 10
+				:fill-pointer 5
+				:initial-element #\a
+				:element-type 'character)))
+	,(car body)
+	(format t "... CHARACTER")
+	(finish-output)
+	(flet ((reset ()
+		 (setf (fill-pointer string) 10)
+		 (fill string #\a)
+		 (setf (fill-pointer string) 5)))
+	  (declare (ignorable #'reset))
+	  ,@(cdr body))))))
+
 (declaim (notinline opaque-identity))
 (defun opaque-identity (x) x)
 ;;; Accessor SUBSEQ
 (sequence-bounding-indices-test
- (format t "~&/Accessor SUBSEQ~%")
+ (format t "~&/Accessor SUBSEQ") 
  (assert (string= (subseq string 0 5) "aaaaa"))
  (assert (raises-error? (subseq string 0 6)))
  (assert (raises-error? (subseq string (opaque-identity -1) 5)))
@@ -395,7 +416,7 @@
 
 ;;; Function COUNT, COUNT-IF, COUNT-IF-NOT
 (sequence-bounding-indices-test
- (format t "~&/Function COUNT, COUNT-IF, COUNT-IF-NOT")
+ (format t "~&/Function COUNT, COUNT-IF, COUNT-IF-NOT") 
  (assert (= (count #\a string :start 0 :end nil) 5))
  (assert (= (count #\a string :start 0 :end 5) 5))
  (assert (raises-error? (count #\a string :start 0 :end 6)))
@@ -425,7 +446,7 @@
 
 ;;; Function FILL
 (sequence-bounding-indices-test
- (format t "~&/Function FILL~%")
+ (format t "~&/Function FILL") 
  (assert (string= (fill string #\b :start 0 :end 5) "bbbbb"))
  (assert (string= (fill string #\c :start 0 :end nil) "ccccc"))
  (assert (raises-error? (fill string #\d :start 0 :end 6)))
@@ -435,7 +456,7 @@
 
 ;;; Function FIND, FIND-IF, FIND-IF-NOT
 (sequence-bounding-indices-test
- (format t "~&/Function FIND, FIND-IF, FIND-IF-NOT~%")
+ (format t "~&/Function FIND, FIND-IF, FIND-IF-NOT") 
  (assert (char= (find #\a string :start 0 :end nil) #\a))
  (assert (char= (find #\a string :start 0 :end 5) #\a))
  (assert (raises-error? (find #\a string :start 0 :end 6)))
@@ -465,7 +486,7 @@
 
 ;;; Function MISMATCH
 (sequence-bounding-indices-test
- (format t "~&/Function MISMATCH~%")
+ (format t "~&/Function MISMATCH") 
  (assert (null (mismatch string "aaaaa" :start1 0 :end1 nil)))
  (assert (= (mismatch "aaab" string :start2 0 :end2 4) 3))
  (assert (raises-error? (mismatch "aaaaaa" string :start2 0 :end2 6)))
@@ -475,7 +496,7 @@
 
 ;;; Function PARSE-INTEGER
 (sequence-bounding-indices-test
- (format t "~&/Function PARSE-INTEGER~%")
+ (format t "~&/Function PARSE-INTEGER") 
  (setf (fill-pointer string) 10)
  (setf (subseq string 0 10) "1234567890")
  (setf (fill-pointer string) 5)
@@ -488,7 +509,7 @@
 
 ;;; Function PARSE-NAMESTRING
 (sequence-bounding-indices-test
- (format t "~&/Function PARSE-NAMESTRING~%")
+ (format t "~&/Function PARSE-NAMESTRING") 
  (setf (fill-pointer string) 10)
  (setf (subseq string 0 10) "/dev/ /tmp")
  (setf (fill-pointer string) 5)
@@ -511,7 +532,8 @@
 
 ;;; Function POSITION, POSITION-IF, POSITION-IF-NOT
 (sequence-bounding-indices-test
- (format t "~&/Function POSITION, POSITION-IF, POSITION-IF-NOT~%")
+ (format t "~&/Function POSITION, POSITION-IF, POSITION-IF-NOT")
+ 
  (assert (= (position #\a string :start 0 :end nil) 0))
  (assert (= (position #\a string :start 0 :end 5) 0))
  (assert (raises-error? (position #\a string :start 0 :end 6)))
@@ -541,7 +563,7 @@
 
 ;;; Function READ-FROM-STRING
 (sequence-bounding-indices-test
- (format t "~&/Function READ-FROM-STRING~%")
+ (format t "~&/Function READ-FROM-STRING") 
  (setf (subseq string 0 5) "(a b)")
  (assert (equal (read-from-string string nil nil :start 0 :end 5) '(a b)))
  (assert (equal (read-from-string string nil nil :start 0 :end nil) '(a b)))
@@ -552,7 +574,7 @@
 
 ;;; Function REDUCE
 (sequence-bounding-indices-test
- (format t "~&/Function REDUCE~%")
+ (format t "~&/Function REDUCE") 
  (setf (subseq string 0 5) "abcde")
  (assert (equal (reduce #'list* string :from-end t :start 0 :end nil)
 		'(#\a #\b #\c #\d . #\e)))
@@ -566,7 +588,7 @@
 ;;; Function REMOVE, REMOVE-IF, REMOVE-IF-NOT, DELETE, DELETE-IF,
 ;;; DELETE-IF-NOT
 (sequence-bounding-indices-test
- (format t "~&/Function REMOVE, REMOVE-IF, REMOVE-IF-NOT, ...~%")
+ (format t "~&/Function REMOVE, REMOVE-IF, REMOVE-IF-NOT, ...") 
  (assert (equal (remove #\a string :start 0 :end nil) ""))
  (assert (equal (remove #\a string :start 0 :end 5) ""))
  (assert (raises-error? (remove #\a string :start 0 :end 6)))
@@ -596,7 +618,7 @@
  (assert (raises-error?
 	  (remove-if-not #'alpha-char-p string :start 6 :end 9))))
 (sequence-bounding-indices-test
- (format t "~&/... DELETE, DELETE-IF, DELETE-IF-NOT")
+ (format t "~&/... DELETE, DELETE-IF, DELETE-IF-NOT") 
  (assert (equal (delete #\a string :start 0 :end nil) ""))
  (reset)
  (assert (equal (delete #\a string :start 0 :end 5) ""))
@@ -645,7 +667,7 @@
 
 ;;; Function REMOVE-DUPLICATES, DELETE-DUPLICATES
 (sequence-bounding-indices-test
- (format t "~&/Function REMOVE-DUPLICATES, DELETE-DUPLICATES~%")
+ (format t "~&/Function REMOVE-DUPLICATES, DELETE-DUPLICATES") 
  (assert (string= (remove-duplicates string :start 0 :end 5) "a"))
  (assert (string= (remove-duplicates string :start 0 :end nil) "a"))
  (assert (raises-error? (remove-duplicates string :start 0 :end 6)))
@@ -666,7 +688,7 @@
 
 ;;; Function REPLACE
 (sequence-bounding-indices-test
- (format t "~&/Function REPLACE~%")
+ (format t "~&/Function REPLACE") 
  (assert (string= (replace string "bbbbb" :start1 0 :end1 5) "bbbbb"))
  (assert (string= (replace (copy-seq "ccccc")
 			   string
@@ -678,7 +700,7 @@
 
 ;;; Function SEARCH
 (sequence-bounding-indices-test
- (format t "~&/Function SEARCH~%")
+ (format t "~&/Function SEARCH") 
  (assert (= (search "aa" string :start2 0 :end2 5) 0))
  (assert (null (search string "aa" :start1 0 :end2 nil)))
  (assert (raises-error? (search "aa" string :start2 0 :end2 6)))
@@ -696,11 +718,11 @@
     (assert (raises-error? (,fn string :start 6 :end 9)))))
   
 (sequence-bounding-indices-test
- (format t "~&/Function STRING-UPCASE, STRING-DOWNCASE, STRING-CAPITALIZE, ...~%")
+ (format t "~&/Function STRING-UPCASE, STRING-DOWNCASE, STRING-CAPITALIZE, ...")
  (string-case-frob string-upcase)
  (string-case-frob string-downcase)
  (string-case-frob string-capitalize)
- (format t "~&/... NSTRING-UPCASE, NSTRING-DOWNCASE, NSTRING-CAPITALIZE~%")
+ (format t "~&/... NSTRING-UPCASE, NSTRING-DOWNCASE, NSTRING-CAPITALIZE")
  (string-case-frob nstring-upcase)
  (string-case-frob nstring-downcase)
  (string-case-frob nstring-capitalize))
@@ -728,12 +750,12 @@
  (string-predicate-frob string<=)
  (string-predicate-frob string>=))
 (sequence-bounding-indices-test
- (format t "~&/... STRING-EQUAL, STRING-NOT-EQUAL, STRING-LESSP, ...~%")
+ (format t "~&/... STRING-EQUAL, STRING-NOT-EQUAL, STRING-LESSP, ...")
  (string-predicate-frob string-equal)
  (string-predicate-frob string-not-equal)
  (string-predicate-frob string-lessp))
 (sequence-bounding-indices-test
- (format t "~&/... STRING-GREATERP, STRING-NOT-GREATERP, STRING-NOT-LESSP~%")
+ (format t "~&/... STRING-GREATERP, STRING-NOT-GREATERP, STRING-NOT-LESSP")
  (string-predicate-frob string-greaterp)
  (string-predicate-frob string-not-greaterp)
  (string-predicate-frob string-not-lessp))
@@ -741,7 +763,7 @@
 ;;; Function SUBSTITUTE, SUBSTITUTE-IF, SUBSTITUTE-IF-NOT,
 ;;; NSUBSTITUTE, NSUBSTITUTE-IF, NSUBSTITUTE-IF-NOT
 (sequence-bounding-indices-test
- (format t "~&/Function SUBSTITUTE, SUBSTITUTE-IF, SUBSTITUTE-IF-NOT, ...~%")
+ (format t "~&/Function SUBSTITUTE, SUBSTITUTE-IF, SUBSTITUTE-IF-NOT, ...")
  (assert (string= (substitute #\b #\a string :start 0 :end 5) "bbbbb"))
  (assert (string= (substitute #\c #\a string :start 0 :end nil)
 		  "ccccc"))
@@ -778,7 +800,7 @@
  (assert (raises-error? (substitute-if-not #\b #'alpha-char-p string
 					   :start 6 :end 9))))
 (sequence-bounding-indices-test
- (format t "~&/... NSUBSTITUTE, NSUBSTITUTE-IF, NSUBSTITUTE-IF-NOT~%")
+ (format t "~&/... NSUBSTITUTE, NSUBSTITUTE-IF, NSUBSTITUTE-IF-NOT")
  (assert (string= (nsubstitute #\b #\a string :start 0 :end 5) "bbbbb"))
  (reset)
  (assert (string= (nsubstitute #\c #\a string :start 0 :end nil)
@@ -833,7 +855,7 @@
 					    :start 6 :end 9))))
 ;;; Function WRITE-STRING, WRITE-LINE
 (sequence-bounding-indices-test
- (format t "~&/Function WRITE-STRING, WRITE-LINE~%")
+ (format t "~&/Function WRITE-STRING, WRITE-LINE")
  (write-string string *standard-output* :start 0 :end 5)
  (write-string string *standard-output* :start 0 :end nil)
  (assert (raises-error? (write-string string *standard-output*
@@ -857,7 +879,7 @@
 
 ;;; Macro WITH-INPUT-FROM-STRING
 (sequence-bounding-indices-test
- (format t "~&/Macro WITH-INPUT-FROM-STRING~%")
+ (format t "~&/Macro WITH-INPUT-FROM-STRING")
  (with-input-from-string (s string :start 0 :end 5)
    (assert (char= (read-char s) #\a)))
  (with-input-from-string (s string :start 0 :end nil)
diff -urN sbcl-0.8.16/tests/type.before-xc.lisp sbcl-0.8.16.patched/tests/type.before-xc.lisp
--- sbcl-0.8.16/tests/type.before-xc.lisp	2003-07-04 07:18:25.000000000 +0200
+++ sbcl-0.8.16.patched/tests/type.before-xc.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -209,4 +209,11 @@
 			(specifier-type '(or (single-float -1.0 1.0)
 					     (single-float 0.1))))))
 
+(assert (sb-xc:typep #\, 'character))
+(assert (sb-xc:typep #\@ 'character))
+
+(assert (type= (type-intersection (specifier-type '(member #\a #\c #\e))
+				  (specifier-type '(member #\b #\c #\f)))
+	       (specifier-type '(member #\c))))
+
 (/show "done with tests/type.before-xc.lisp")
diff -urN sbcl-0.8.16/tests/type.impure.lisp sbcl-0.8.16.patched/tests/type.impure.lisp
--- sbcl-0.8.16/tests/type.impure.lisp	2004-05-27 18:07:06.000000000 +0200
+++ sbcl-0.8.16.patched/tests/type.impure.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -30,7 +30,7 @@
 	       (real 4 8) (real -1 7) (real 2 11)
 	       null symbol keyword
 	       (member #\a #\b #\c) (member 1 #\a) (member 3.0 3.3)
-	       (integer -1 1)
+	       (member #\a #\c #\d #\f) (integer -1 1)
 	       unsigned-byte
 	       (rational -1 7) (rational -2 4)
 	       ratio
